//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property description "Laguerre PPO"
#property description "made by mladen"
#property description "for more visit www.forex-tsd.com"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  clrSilver
#property indicator_color2  clrSilver
#property indicator_color3  clrGreen
#property indicator_color4  clrLimeGreen
#property indicator_color5  clrOrangeRed
#property indicator_color6  clrSandyBrown
#property indicator_color7  clrDarkGray
#property indicator_color8  clrDarkGray
#property strict

extern int    LookBack        = 200;          // Look back period
extern double GammaFast       = 0.4;          // Fast Laguerre gamma value
extern double GammaSlow       = 0.8;          // Slow Laguerre gamma value 
extern int    Price           = PRICE_MEDIAN; // Price
extern double Percent1        = 80;           // Lower percent to use
extern double Percent2        = 90;           // Higher percent to use
extern bool   alertsOn        = false;        // Turn alerts on?
extern bool   alertsOnCurrent = true;         // Alerts on current (still opened) bar?
extern bool   alertsMessage   = true;         // Alerts should show pop-up message?
extern bool   alertsSound     = false;        // Alerts should play alert sound?
extern bool   alertsPushNotif = false;        // Alerts should send push notification?
extern bool   alertsEmail     = false;        // Alerts should send email?
extern int    barsWidth       = 2;            // Bars width for display

double pctRankT[],pctRankB[],histnu[],histnd[],histd[],histdd[],histu[],histuu[],ppoT[],ppoB[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,histnu);
   SetIndexBuffer(1,histnd);
   SetIndexBuffer(2,histu);
   SetIndexBuffer(3,histuu);
   SetIndexBuffer(4,histdd);
   SetIndexBuffer(5,histd);
   SetIndexBuffer(6,pctRankT);
   SetIndexBuffer(7,pctRankB);
   SetIndexBuffer(8,ppoT);
   SetIndexBuffer(9,ppoB);
      for (int i=0; i<6; i++) SetIndexStyle(i,DRAW_HISTOGRAM,EMPTY,barsWidth);
      SetLevelValue(0, Percent1/100);
      SetLevelValue(1, Percent2/100);
      SetLevelValue(2,-Percent2/100);
      SetLevelValue(3,-Percent1/100);
   return (0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)   
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double lmas = iLaGuerreFilter(price, GammaFast, i, 0);
         double lmal = iLaGuerreFilter(price, GammaSlow, i, 1);
            ppoT[i] = (lmas-lmal)/lmal*100.0;
            ppoB[i] = (lmal-lmas)/lmal*100.0;
            double topvalueMinus    = 0;
            double topvaluePlus     = 0;
            double bottomvalueMinus = 0;
            double bottomvaluePlus  = 0;
            for (int k = 0; k<LookBack && (i+k+1)<Bars; k++) 
            {
               if (ppoT[i+k+1]<ppoT[i]) 
                     topvalueMinus++;
               else  topvaluePlus++;
               if (ppoB[i+k+1]<ppoB[i]) 
                     bottomvalueMinus++;
               else  bottomvaluePlus++;
            }
            if (topvalueMinus+topvaluePlus!=0)       pctRankT[i] =   topvalueMinus   / (topvalueMinus+topvaluePlus);
            if (bottomvalueMinus+bottomvaluePlus!=0) pctRankB[i] = (bottomvalueMinus / (bottomvalueMinus+bottomvaluePlus)) *-1;
               histnd[i]   = EMPTY_VALUE;
               histnu[i]   = EMPTY_VALUE;
               histu[i]    = EMPTY_VALUE;
               histd[i]    = EMPTY_VALUE;
               int state = 0;
               while (true)
               {
                  if (pctRankT[i]> MathMax(Percent1,Percent2)/100) { state= 2; break; }
                  if (pctRankT[i]> MathMin(Percent1,Percent2)/100) { state= 1; break; }
                  if (pctRankB[i]<-MathMax(Percent1,Percent2)/100) { state=-2; break; }
                  if (pctRankB[i]<-MathMin(Percent1,Percent2)/100) { state=-1; break; }
                  break;
               }
               switch(state)
               {
                  case  1: histd[i]  = pctRankT[i]; histnd[i] = pctRankB[i]; break; 
                  case  2: histdd[i] = pctRankT[i]; histnd[i] = pctRankB[i]; break; 
                  case -2: histuu[i] = pctRankB[i]; histnu[i] = pctRankT[i]; break; 
                  case -1: histu[i]  = pctRankB[i]; histnu[i] = pctRankT[i]; break; 
                  default: histnd[i] = pctRankB[i]; histnu[i] = pctRankT[i]; 
               }                  
   }
   manageAlerts();
   return (0);   
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define laguerreInstances 2
double workLagFil[][laguerreInstances*4];
double iLaGuerreFilter(double price, double gamma, int i, int instanceNo=0)
{
   if (ArrayRange(workLagFil,0)!=Bars) ArrayResize(workLagFil,Bars); i=Bars-i-1; instanceNo*=4;
   if (gamma<=0) return(price);

   //
   //
   //
   //
   //

   if (i<1) { for (int k=0; k<4; k++) workLagFil[i][instanceNo+k] = price; }
   else
   {
      workLagFil[i][instanceNo+0] = (1.0 - gamma)*price                                                + gamma*workLagFil[i-1][instanceNo+0];
	   workLagFil[i][instanceNo+1] = -gamma*workLagFil[i][instanceNo+0] + workLagFil[i-1][instanceNo+0] + gamma*workLagFil[i-1][instanceNo+1];
	   workLagFil[i][instanceNo+2] = -gamma*workLagFil[i][instanceNo+1] + workLagFil[i-1][instanceNo+1] + gamma*workLagFil[i-1][instanceNo+2];
	   workLagFil[i][instanceNo+3] = -gamma*workLagFil[i][instanceNo+2] + workLagFil[i-1][instanceNo+2] + gamma*workLagFil[i-1][instanceNo+3];
   }
   return((workLagFil[i][instanceNo+0]+2.0*workLagFil[i][instanceNo+1]+2.0*workLagFil[i][instanceNo+2]+workLagFil[i][instanceNo+3])/6.0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      static datetime prevTime1  = 0;
      static string   prevAlert1 = "";
         if (histd[whichBar] != EMPTY_VALUE && histd[whichBar+1]==EMPTY_VALUE) doAlert(prevAlert1,prevTime1,"down");
      static datetime prevTime2  = 0;
      static string   prevAlert2 = "";
         if (histu[whichBar] != EMPTY_VALUE && histu[whichBar+1]==EMPTY_VALUE) doAlert(prevAlert2,prevTime2,"up");
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Laguerre PPO signal "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(Symbol()+" Laguerre PPO",message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound("alert2.wav");
   }
}